#ifndef EFL_GENERATED_EVAS_SMART_CLIPPED_HH
#define EFL_GENERATED_EVAS_SMART_CLIPPED_HH

#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "evas_smart_clipped.eo.h"
}

#include "evas_object_smart.eo.hh"

namespace evas { 

struct smart_clipped
      : evas::object_smart
{
   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit smart_clipped(Eo* eo)
      : evas::object_smart(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit smart_clipped(std::nullptr_t)
      : evas::object_smart(nullptr)
   {}

   smart_clipped(efl::eo::parent_type _p = (efl::eo::parent = nullptr))
      : smart_clipped(_c0(_p))
   {}

   /// @brief Copy Constructor.
   ///
   smart_clipped(smart_clipped const& other)
      : evas::object_smart(eo_ref(other._eo_ptr()))
   {}

   ~smart_clipped() {}

   static Eo_Class const* _eo_class()
   {
      return(EVAS_SMART_CLIPPED_CLASS);
   }

private:
   static Eo* _c0(efl::eo::parent_type _p)
   {
      return eo_add_custom(EVAS_SMART_CLIPPED_CLASS, _p._eo_raw, eo_constructor());
   }

};
} 

namespace efl { namespace eo { namespace detail {

template<>
struct operations< evas::smart_clipped >
{
   template <typename T>
   struct type
   {
   };
};


template<>
struct operation_description_class_size< evas::smart_clipped >
{
   static const int value = 0;
};

template <typename T>
int initialize_operation_description(efl::eo::detail::tag<evas::smart_clipped>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   return 0;
}
inline void
call_constructor(tag< evas::smart_clipped >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<evas::smart_clipped, ::std::tuple<> > const& args)
{
   (void)args;
   eo_do_super(eo, cls, ::eo_constructor());
}

inline void
call_constructor(tag< evas::smart_clipped >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<evas::smart_clipped, ::std::tuple<efl::eo::parent_type> > const& args)
{
   eo_do_super(eo, cls, ::eo_constructor());
   eo_do(eo, ::eo_parent_set(args.get<0>()._eo_raw));
}

template<>
struct extension_inheritance< evas::smart_clipped>
{
   template <typename U>
   struct type
   {
      operator evas::smart_clipped() const
      {
         return evas::smart_clipped(eo_ref(static_cast<U const*>(this)->_eo_ptr()));
      }

   };
};

inline Eo_Class const* get_eo_class(tag<evas::smart_clipped>)
{
   return (EVAS_SMART_CLIPPED_CLASS);
}

} } }
#endif // EFL_GENERATED_EVAS_SMART_CLIPPED_HH

